#include <prom.h>

void srtest(void)
{
  unsigned long sr[16];

  prom_printf("SR registers:\n");
  asm volatile("mfst %0,0" : "=r"(sr[0]));
  asm volatile("mfsr %0,1" : "=r"(sr[1]));
  asm volatile("mfsr %0,2" : "=r"(sr[2]));
  asm volatile("mfsr %0,3" : "=r"(sr[3]));
  asm volatile("mfsr %0,4" : "=r"(sr[4]));
  asm volatile("mfsr %0,5" : "=r"(sr[5]));
  asm volatile("mfsr %0,6" : "=r"(sr[6]));
  asm volatile("mfsr %0,7" : "=r"(sr[7]));
  asm volatile("mfsr %0,8" : "=r"(sr[8]));
  asm volatile("mfsr %0,9" : "=r"(sr[9]));
  asm volatile("mfsr %0,10" : "=r"(sr[10]));
  asm volatile("mfsr %0,11" : "=r"(sr[11]));
  asm volatile("mfsr %0,12" : "=r"(sr[12]));
  asm volatile("mfsr %0,13" : "=r"(sr[13]));
  asm volatile("mfsr %0,14" : "=r"(sr[14]));
  asm volatile("mfsr %0,15" : "=r"(sr[15]));
  prom_printf("SR0 : 0x%08lx SR1 : 0x%08lx  SR2 : 0x%08lx SR3 : 0x%08lx\n",
              sr[0], sr[1], sr[2], sr[3]);
  prom_printf("SR4 : 0x%08lx SR5 : 0x%08lx  SR6 : 0x%08lx SR7 : 0x%08lx\n",
              sr[4], sr[5], sr[6], sr[7]);
  prom_printf("SR8 : 0x%08lx SR9 : 0x%08lx  SR10: 0x%08lx SR11: 0x%08lx\n",
              sr[8], sr[9], sr[10], sr[11]);
  prom_printf("SR12: 0x%08lx SR13: 0x%08lx  SR14: 0x%08lx SR15: 0x%08lx\n",
              sr[12], sr[13], sr[14], sr[15]);
}
