#include <prom.h>

void battest(void)
{
  unsigned long bats[16];

  prom_printf("BAT registers:\n");
  asm volatile("mfibatl %0,0" : "=r"(bats[0]));
  asm volatile("mfibatu %0,0" : "=r"(bats[1]));
  asm volatile("mfibatl %0,1" : "=r"(bats[2]));
  asm volatile("mfibatu %0,1" : "=r"(bats[3]));
  asm volatile("mfibatl %0,2" : "=r"(bats[4]));
  asm volatile("mfibatu %0,2" : "=r"(bats[5]));
  asm volatile("mfibatl %0,3" : "=r"(bats[6]));
  asm volatile("mfibatu %0,3" : "=r"(bats[7]));
  asm volatile("mfdbatl %0,0" : "=r"(bats[8]));
  asm volatile("mfdbatu %0,0" : "=r"(bats[9]));
  asm volatile("mfdbatl %0,1" : "=r"(bats[10]));
  asm volatile("mfdbatu %0,1" : "=r"(bats[11]));
  asm volatile("mfdbatl %0,2" : "=r"(bats[12]));
  asm volatile("mfdbatu %0,2" : "=r"(bats[13]));
  asm volatile("mfdbatl %0,3" : "=r"(bats[14]));
  asm volatile("mfdbatu %0,3" : "=r"(bats[15]));
  prom_printf("IBAT0L: 0x%08lx IBAT0U: 0x%08lx  IBAT1L: 0x%08lx IBAT1U: 0x%08lx\n",
              bats[0], bats[1], bats[2], bats[3]);
  prom_printf("IBAT2L: 0x%08lx IBAT2U: 0x%08lx  IBAT3L: 0x%08lx IBAT3U: 0x%08lx\n",
              bats[4], bats[5], bats[6], bats[7]);
  prom_printf("DBAT0L: 0x%08lx DBAT0U: 0x%08lx  DBAT1L: 0x%08lx DBAT1U: 0x%08lx\n",
              bats[8], bats[9], bats[10], bats[11]);
  prom_printf("DBAT2L: 0x%08lx DBAT2U: 0x%08lx  DBAT3L: 0x%08lx DBAT3U: 0x%08lx\n",
              bats[12], bats[13], bats[14], bats[15]);
}
